//
// list of spells - #include this into a c file to use
//
// Copyright (C) 2006  Nathan (Acorn) Pooley
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// version 2 as published by the Free Software Foundation.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License (gpl.txt) for more details. 
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
// 
// You can contact the author, Nathan (Acorn) Pooley, by writing
// to Nathan (Acorn) Pooley, 949 Buckeye Drive, Sunnyvale, CA  94086, USA
// or through the form at http://www.rawbw.com/~acorn/wand/feedback.html
//
//
//
// 
//#@DOC@ list of spells - #include this into a c file to use
//
//  Use like this:
//
//      #include "spells.h"
//          
//      Spell spells[] = {
//      #include "spells.c"
//          {0},
//      };
//
//


//
// SPELL_FLG_VITAL - vital spell (used in game)
// SPELL_FLG_DUMMY - dummy spell to prevent false positives
// SPELL_FLG_BOOK  - used in the book in "how to cast spells" section
// SPELL_FLG_WAND  - use it in the wand
// SPELL_FLG_INFO  - has a spellinfo in wand, so do not create one
//
// NOTE: Only VITAL spells are included in wand by default
//
#define SPELL_FLG_VITAL		0x0001
#define SPELL_FLG_DUMMY		0x0002
#define SPELL_FLG_BOOK		0x0004
#define SPELL_FLG_WAND		0x1000

#define SPELL_FLG_INFO	0x2000
//#define SPELL_FLG_INFO		0x8000

//
// internal use only flags
//
#define SPELL_FLG_FIRST		0x0010


//
// clue spells
//
//  Need more tweaking attention:
//      spell           codes 				notes
//      -----------		------				--------
//  	hufflepuff		SR
//  	loop vs one		DSK					get rid of loop or one??
//  	metacarpus		D
//  	noel            SR                  reverse loops - get 
//  	poem			SRK					reverse loops - kill poem or noel
//  	sanctuary		SR					reverse loops
//  	prince			SR					need to check 2nd version
//  	shropshire      R
//  	squirting       RS					check against draconis
//  	urn & sword		DS					urn & sword are close
//
//
//  S = need more study
//  R = need to re-tweak
//  D = need mode spell cast data
//  K = look, into killing this one
//
// KILLED
//  	rankle			K					killed - is that OK?
//  	uncle			DS					*very* close to hush
//  	emergency		K
//  	inocardi		K
//  	masochist		SK					needed?
//
//
	{ 0x3001,  30,  15, "archstones", 	"alssdoms" },	// tweaked1
	{ 0x3001,  35,  30, "slytherin", 	"sliholim" },	// tweaked1
	{ 0x3001,  25,  10, "hufflepuff1", 	"huflduf" },	// tweaked1
	{ 0x3001,  25,  10, "hufflepuff2", 	"hufolduf" },	// tweaked1  2nd
	{ 0x3001,  25,  10, "ravenclaw1", 	"lafymkla" },	// tweaked1
	{ 0x3001,  25,  10, "ravenclaw2", 	"lafymklo" },	// tweaked1  2nd
	{ 0x3001,  50,  30, "gryffindor", 	"glifimdol" },	// tweaked1
	{ 0x3001,  20,  15, "dormiens", 	"dolmeyms" },	// tweaked1
	{ 0x3001,  10,  20, "republic1", 	"ledudlik" },	// tweaked1
	{ 0x3001,  10,  20, "republic2", 	"lidudlik" },	// tweaked1
	{ 0x3001,  10,  20, "republic3", 	"lodudlik" },	// tweaked1
	{ 0x3001,  10,  20, "republic4", 	"lududlik" },	// tweaked1
	{ 0x3001,  25,  10, "metacarpus1", 	"mydukaldos" },	// tweaked1
	{ 0x3001,  25,  10, "metacarpus2",  "mydukaldus" },	// tweaked1  2nd
	{ 0x3001,  25,  10, "metacarpus3",  "mydukaldis" },	// tweaked1  2nd
	{ 0x3001,  25,  10, "metacarpus4",  "mydykaldos" },	// tweaked1  2nd
	{ 0x3001,  25,  10, "metacarpus5",  "mydykaldus" },	// tweaked1  2nd
	{ 0x3001,  25,  10, "metacarpus6",  "mydykaldis" },	// tweaked1  2nd
	{ 0x3001,  80,  30, "unmixify",   	"ummiksifa" },	// tweaked1
	{ 0x3001,  10,   1, "shropshire1",  "sladsol" },	// tweaked1
	{ 0x3001,  15,   5, "shropshire2",  "sladsel" },	// tweaked1  2nd
	{ 0x3001,  25,  10, "shropshire3",  "sladsal" },	// tweaked1  2nd
	{ 0x3001,  25,  20, "banana",   	"dumamu" },		// tweaked1
	{ 0x3001,  60,  10, "sanctuary",   	"samksoyle" },	// tweaked1
	{ 0x3001,  25,  10, "squirting", 	"skloldem" },	// tweaked1
	{ 0x3001,  60,  30, "insect", 		"imsykd" },		// tweaked1
	{ 0x3001,  20,  15, "dynamite", 	"damumad" },	// tweaked1
	{ 0x3001,  20,  10, "ziggurat", 	"sigolad" },	// tweaked1
	{ 0x3001,  10,  10, "rowling1",     "lolem" },		// tweaked1
	{ 0x3001,  10,  10, "rowling2",     "lolim" },		// tweaked1  2nd
	{ 0x3001,  15,  10, "chanters", 	"samdols" },	// tweaked1


	//
	// extras - needed??
	//
	//{ 0x1001,  25,  10, "masochist", 	"masokisd" },	// tweaked1
	//{ 0x1001,  25,  10, "masochist2", "masukisd" },	// tweaked1
	//{ 0x1001,  25,  10, "emergency", 	"emolgymse" },	// tweaked1
	//{ 0x1001,  25,  10, "inocardi",  	"imokalde" },	// tweaked1

	//
	// needed to keep them from triggering spells
	//
	{ 0x3001,  25,  30, "draconis",    	"dlakomis" },

	//
	// Defence class: NOTE: USE BEST 5!!
	//
	//  NOTE: put one and loop next to each other (or use only 1 of the two)
	//
	{ 0x3001,  10, 15, "wandy",    "lamde" },		// tweaked1
	{ 0x3001,   8,  1, "urn",		"olm" },		// tweaked1
	{ 0x3001,  10, 30, "prince1",    "dlims" },		// tweaked1
	{ 0x3001,  10, 30, "prince2",    "dlimds" },	// tweaked1	 2nd
	{ 0x3001,   5,  4, "one",       "lum" },		// tweaked1
	{ 0x3001,  10,  5, "sword",    "sold" },		// tweaked1

	//
	// OK, but only need 5
	//

	//
	// reject
	//
	//{ 0x3001,  15,  1, "lock",     "lak" },
	//{ 0x3001,   5,  3, "loop",     "lod" },		// tweaked1 trouble with one
	//{ 0x3001,   5, 10, "pear",     "dyl" },			// tweaked1  trouble with cheese
	{ 0x3001,  25, 10, "gorilla",    "golilu" },	// tweaked1  hard

	//
	// class 
	//
	{ 0x3000,  40,   5, "ankle",    "amkl" },		// tweaked1
	{ 0x3000,  10,   3, "jaw",      "go" },			// tweaked1

	{ 0x3001,  25,   1, "poem",    	"doym" },		// tweaked1
	{ 0x3000,  10,   5, "noel",      "moyl" },		// tweaked1	BAD

	//
	// From book
	//
	{ 0x3004,  3,   1, "yay",      "ga" },			// tweaked1
	{ 0x3004,  5,   1, "ask",      "ask" },			// tweaked1
	{ 0x3004, 10,   1, "dad",      "dad" },			// tweaked1
	{ 0x3004, 20,   3, "cheese",   "ses" },			// tweaked1
	{ 0x3004, 20,  15, "hello",    "hylo" },		// tweaked1
	{ 0x3002, 15,   5, "hush",    "hus" },			// tweaked1


	//
	// rankle prevents false positives with ankle->dad
	//
	//{ 0x1000,  10,   5, "rankle",      "lamkl" },	// BAD
	//{ 0x1000,  15,   1, "uncle",    "umkl" },		// tweaked1


	//
	// extras
	//
	{ 0x3000,  10,  1, "fast",        	"fasd" },
	//{ 0x3000,  10,  1, "slow1",       	"slo" },	BAD - sword conflict
	{ 0x3000,  10,  1, "slow2",       	"slol" },

#if 0
	//
	// old (bad) defense class
	//
#if 1
	//{ 0x1001,  15,  1, "dear",     "del" },		// conflicts with cheese
	//{ 0x1001,  15,  1, "not",      "mad" },	// conflicts with no
	//{ 0x1001,  25,  1, "unix",     "gomiks" },	// conflicts with dormiens & prince
#if 0
	{ 0x1001,  5,  2, "or",       "ol" },
#endif
	//
	//more defence class
	//
	//{ 0x1001,  15,  5, "poor",    "dol" },
	//{ 0x1001,  15,  5, "ring",     "lim" }, - CONFLICT WITH CHEESE
	//{ 0x1001,  15,  5, "sex",    "syks" }, - CONFLICT WITH CHEESE
#endif
#endif

#if 0
	//
	// yes/no
	//
	{ 0x1001,  3,   1, "yes",      "gys" },
	{ 0x1001,  3,   1, "no",      "mo" },
#endif



#if 0
	{ 0x0000,  10,  30, "my",		"ma" },
	{ 0x0000,  10,  30, "by",		"da" },
#endif



#if 0
	{ 0x0002,  10,  10, "puzzle",   	"dusl" },
	{ 0x0000,  10,  10, "goodbye",     	"godda" },
	{ 0x0000,  10,  10, "flower1",     	"flalol" },
	{ 0x0000,  10,  10, "flower2",     	"flal" },
	{ 0x0000,  10,  10, "flower3",     	"flaol" },
	{ 0x0000,  10,  10, "mombo",       	"mamdo" },
	{ 0x0000,  10,  10, "sentimental", 	"symdimymdal" },
	{ 0x0000,  10,  10, "fast",        	"fasd" },
	{ 0x0000,  10,  10, "library",     	"ladlyle" },
	{ 0x0000,  10,  10, "church",      	"sols" },
	{ 0x0000,  10,  10, "squib",       	"sklid" },
	{ 0x0000,  10,  10, "two_thousand_nimbus",  "dlohasamdmimdus" },
	{ 0x0000,  10,  10, "nimbus",      	"mimdus" },
	{ 0x0000,  10,  10, "two_thousand",	"dlohasamd" },
#endif

#if 0
	//
	// see http://www.mugglenet.com/info/other/spells.shtml
	//
	//{ 0x0000,  10,  10, "accio",       "akeo" },		// objects fly to caster
	//{ 0x0000,  10,  10, "getonaraftwiththeweasleys",		"ddd" },
	//{ 0x0000,  10,  10, "hogwartsandthedraconianprophecy",		"ddd" },
	//{ 0x0000,  10,  10, "lurempistrix",		"ddd" },
	//{ 0x0000,  10,  10, "lustrumpistrix",		"ddd" },
	//{ 0x0000,  10,  10, "relaxed alchemical dilettantes investigating kurious spells",		"ddd" },
	//{ 0x0000,  10,  10, "snapes psychic intelligence extraction syndicate",	"ddd" },
	{ 0x1000,  10,  10, "abera_cadabera","adlukadadlu" },
	{ 0x1000,  10,  10, "accio",		"asego" },
	{ 0x1000,  10,  10, "acciobrain",	"asegodlam" },
	{ 0x1000,  10,  10, "alakazam",     "alukasam" },
	{ 0x1000,  10,  10, "alohomora",    "alohomolu" },	// unlock doors
	{ 0x1000,  10,  10, "aparecium",    "adaleseum" },	// reveal invisible ink
	{ 0x1000,  10,  10, "apparate",     "adalad" },	// move from one place and appear 
	{ 0x1000,  10,  10, "astronomy",	"asdlamome" },
	{ 0x1000,  10,  10, "auror",		"olol" },
	{ 0x1000,  10,  10, "aurormonks",	"ololmumks" },
	{ 0x1000,  10,  10, "avada_kedavra", "ufadakydaflu" }, // destroy, kill (green light)
	{ 0x1000,  10,  10, "avis",         "afis" },	// conjour flock of birds
	{ 0x1000,  10,  10, "blinded",		"dlamdyd" },
	{ 0x1000,  10,  10, "blindedbyquidditch",		"dlamdyddaklidis" },
	{ 0x1000,  10,  10, "bones",		"doms" },
	{ 0x1000,  10,  10, "brain",		"dlam" },
	{ 0x1000,  10,  10, "breakfast",	"dlakfasd" },
	{ 0x1000,  10,  10, "briny",		"dlame" },
	{ 0x1000,  10,  10, "brinydeep",	"dlameded" },
	{ 0x1000,  10,  10, "broomstick",	"domsdik" },
	{ 0x1000,  10,  10, "coed",		     "koyd" },
	{ 0x1000,  10,  10, "coedastronomy", "koydasdlamome" },
	{ 0x1000,  10,  10, "colloportus",   "kolodoldus" },	// lock a door
	{ 0x1000,  10,  10, "confundus",     "kamfumdus" },	// confuse
	{ 0x1000,  10,  10, "continental",	 "kamdimymdal" },
	{ 0x1000,  10,  10, "continentalbreakfast",		"kamdimymdaldlykfasd" },
	{ 0x1000,  10,  10, "deep",		    "ded" },
	{ 0x1000,  10,  10, "desmodus",		"dysmodus" },
	{ 0x1000,  10,  10, "desmodusrotundus",		"dysmoduslodumdus" },
	{ 0x1000,  10,  10, "device",		"defas" },
	{ 0x1000,  10,  10, "diffindo",     "difimdo" },	// reveal invisible ink
	{ 0x1000,  10,  10, "dissendium",   "disymdeum" },	// reveal a path - used for path 
	{ 0x1000,  10,  10, "draconian",	"dlakomeam" },
	{ 0x1000,  10,  10, "draconus",		"dlakomus" },
	{ 0x1000,  10,  10, "draconusdevice","dlakomusdefas" },
	{ 0x1000,  10,  10, "dumbledore",	"dumdldol" },
	{ 0x1000,  10,  10, "engorgio",     "ymgolgeo" },	// enlarge an object
	{ 0x1000,  10,  10, "ennervate",    "ymolfad" },	// revive, esp from stupify
	{ 0x1000,  10,  10, "evanesco",     "yfamysko" },	// make dissapear
	{ 0x1000,  10,  10, "expecto_patronum","yksdykdodadlomum" },	// conjour protector
	{ 0x1000,  10,  10, "expelliarmus", "yksdylemus" },	// make wand fly out of 
	{ 0x1000,  10,  10, "flagrinators",	"flagimadols" },
	{ 0x1000,  10,  10, "golden",		"goldym" },
	{ 0x1000,  10,  10, "goldensnitch",	"goldymsmis" },
	{ 0x1000,  10,  10, "hagrid",		"haglid" },
	{ 0x1000,  10,  10, "harry",		"hale" },
	{ 0x1000,  10,  10, "harrypotter",	"haledadol" },
	{ 0x1000,  10,  10, "hogwarts",		"hoglolds" },
	{ 0x1000,  10,  10, "incendio",     "imsymdeo" },	// create fire
	{ 0x1000,  10,  10, "legilimens",   "lygilimyms" },	// see memories from anothers 
	{ 0x1000,  10,  10, "longshots",	"lomsads" },
	{ 0x1000,  10,  10, "lowkey",		"lolke" },
	{ 0x1000,  10,  10, "lumos",        "lomos" },	// light from end of wand
	{ 0x1000,  10,  10, "lurem",		"lolum" },
	{ 0x1000,  10,  10, "lustrum",		"lusdlum" },
	{ 0x1000,  10,  10, "mcgonagal",	"mkamugl" },
	{ 0x1000,  10,  10, "monks",		"mumks" },
	{ 0x1000,  10,  10, "mudblood",		"muddlud" },
	{ 0x1000,  10,  10, "mudbloodandbones","muddludamddoms" },
	{ 0x1000,  10,  10, "orchideous",  	"olsideus" },	// create flowers at end of wand
	{ 0x1000,  10,  10, "pears",		"dyls" },
	{ 0x1000,  10,  10, "petrificus_totalus","dydlifikusdodalus" },	// prevent victim 
	{ 0x1000,  10,  10, "pimp",			"dimd" },
	{ 0x1000,  10,  10, "pimpmybroomstick","dimdmadlomsdik" },
	{ 0x1000,  10,  10, "pistrix",		"disdliks" },
	{ 0x1000,  10,  10, "potter",		"dadol" },
	{ 0x1000,  10,  10, "prophecy",		"dlafyse" },
	{ 0x1000,  10,  10, "quidditch",	"klidis" },
	{ 0x0000,  10,  10, "radiks",		"ladiks" },
	{ 0x0000,  10,  10, "ravenclaw1",	"lafymklal" },
	{ 0x0000,  10,  10, "ravenclaw2",	"lafymkla" },
	{ 0x0000,  10,  10, "reducto",     	"lydukdo" },	// smash
	{ 0x0000,  10,  10, "relashio",    	"lylaseo" },	// sparks/heat from wand tip
	{ 0x0000,  10,  10, "reparo",      	"ledalo" },	// repair
	{ 0x0000,  10,  10, "rictusempra", 	"likdusymdlu" },	// tickling - uncontrolled 
	{ 0x0000,  10,  10, "rotundus",		"lodumdus" },
	{ 0x0000,  10,  10, "scourgify",    "skolgifa" },	// clean
	{ 0x0000,  10,  10, "serpensortia", "soldymsolseu" },	// create snake from wand
	{ 0x0000,  10,  10, "snape",		"smad" },
	{ 0x0000,  10,  10, "snitch",		"smis" },
	{ 0x0000,  10,  10, "snout",		"smad" },
	{ 0x0000,  10,  10, "spies",		"sdas" },
	{ 0x0000,  10,  10, "stupefy",      "sdodifa" },	// stun (red light)
	{ 0x0000,  10,  10, "tickled",		"dikld" },
	{ 0x0000,  10,  10, "tickledpears",	"diklddyls" },
	{ 0x0000,  10,  10, "xxrated",		"yksyksladyd" },
#endif


#if 0
	//
	// cannot use - too close to other spells
	//
	{ 0x0000,  10,  30, "daddo",       "dado" },
	{ 0x0000,  10,  30, "daddy",       "dade" },
	{ 0x0000,  10,  30, "piano",       "demo" },
	{ 0x0000,  10,  30, "piano",       "deamo" },
	{ 0x0000,  10,  30, "pono",        "domo" },

#endif




