;
; def_182620.inc
;@DOC@ Definitions for PIC 18F2620
;
; Copyright (C) 2006  Nathan (Acorn) Pooley
; 
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; version 2 as published by the Free Software Foundation.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License (gpl.txt) for more details. 
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
; 
; You can contact the author, Nathan (Acorn) Pooley, by writing
; to Nathan (Acorn) Pooley, 949 Buckeye Drive, Sunnyvale, CA  94086, USA
; or through the form at http://www.rawbw.com/~acorn/wand/feedback.html
; 

;	processor	p18f2620
	list    p=pic18f2620
	include <p18f2620.inc>


;############################################
;############### SPR BITS ###################
;############################################

#define b_rd		EECON1,RD
#define b_wr		EECON1,WR
#define b_wren		EECON1,WREN
#define b_wrerr		EECON1,WRERR
#define b_free		EECON1,FREE
#define b_cfgs		EECON1,CFGS
#define b_eepgd		EECON1,EEPGD

#define b_bor		RCON,BOR
#define b_por		RCON,POR
#define b_pd		RCON,PD
#define b_to		RCON,TO
#define b_ri		RCON,RI
#define b_sboren	RCON,SBOREN
#define b_ipen		RCON,IPEN

#define b_gieh		INTCON,GIEH
#define b_giel		INTCON,GIEL
#define b_tmr0ie	INTCON,TMR0IE
#define b_int0ie	INTCON,INT0IE
#define b_rbie		INTCON,RBIE
#define b_tmr0if	INTCON,TMR0IF
#define b_int0if	INTCON,INT0IF
#define b_rbif		INTCON,RBIF

#define b_rbpu		INTCON2,RBPU
#define b_intedg0	INTCON2,INTEDG0
#define b_intedg1	INTCON2,INTEDG1
#define b_intedg2	INTCON2,INTEDG2
#define b_tmr0ip	INTCON2,TMR0IP
#define b_rbip		INTCON2,RBIP

#define b_int2ip	INTCON3,INT2IP
#define b_int1ip	INTCON3,INT1IP
#define b_int2ie	INTCON3,INT2IE
#define b_int1ie	INTCON3,INT1IE
#define b_int2if	INTCON3,INT2IF
#define b_int1if	INTCON3,INT1IF

#define b_eeip		IPR2,EEIP
#define b_bclip		IPR2,BCLIP
#define b_lvdip		IPR2,LVDIP
#define b_tmr3ip	IPR2,TMR3IP
#define b_ccp2ip	IPR2,CCP2P

#define b_eeif		PIR2,EEIF
#define b_bclif		PIR2,BCLIF
#define b_lvdif		PIR2,LVDIF
#define b_tmr3if	PIR2,TMR3IF
#define b_ccp2if	PIR2,CCP2IF

#define b_eeie		PIE2,EEIE
#define b_bclie		IE2,BCLIE
#define b_lvdie		IE2,LVDIE
#define b_tmr3ie	IE2,TMR3IE
#define b_ccp2ie	IE2,CCP2IE

#define b_pspip		IPR1,PSPIP
#define b_adip		IPR1,ADIP
#define b_rcip		IPR1,RCIP
#define b_txip		IPR1,TXIP
#define b_sspip		IPR1,SSPIP
#define b_ccp1ip	IPR1,CCP1IP
#define b_tmr2ip	IPR1,TMR2IP
#define b_tmr1ip	IPR1,TMR1IP

#define b_pspif		PIR1,PSPIF
#define b_adif		PIR1,ADIF
#define b_rcif		PIR1,RCIF
#define b_txif		PIR1,TXIF
#define b_sspif		PIR1,SSPIF
#define b_ccp1if	PIR1,CCP1IF
#define b_tmr2if	PIR1,TMR2IF
#define b_tmr1if	PIR1,TMR1IF

#define b_pspie		PIE1,PSPIE
#define b_adie		PIE1,ADIE
#define b_rcie		PIE1,RCIE
#define b_txie		PIE1,TXIE
#define b_sspie		PIE1,SSPIE
#define b_ccp1ie	PIE1,CCP1IE
#define b_tmr2ie	PIE1,TMR2IE
#define b_tmr1ie	PIE1,TMR1IE

#define b_tmr0on	T0CON,TMR0ON
#define b_t08bit	T0CON,T08BIT
#define b_tocs		T0CON,T0CS
#define b_t0se		T0CON,T0SE
#define b_psa		T0CON,PSA
#define b_t0ps2		T0CON,T0PS2
#define b_t0ps1		T0CON,T0PS1
#define b_t0ps0		T0CON,T0PS0

#define b_tmr2on	T2CON,TMR2ON

#define b_wcol		SSPCON1,WCOL

#define b_bf		SSPSTAT,BF
#define b_s			SSPSTAT,S
#define b_p			SSPSTAT,P

#define b_sen		SSPCON2,SEN
#define b_rsen		SSPCON2,RSEN
#define b_pen		SSPCON2,PEN
#define b_ackstat	SSPCON2,ACKSTAT
#define b_ackdt		SSPCON2,ACKDT

#define b_rx9d 		RCSTA,RX9D
#define b_oerr 		RCSTA,OERR
#define b_ferr 		RCSTA,FERR
#define b_aden 		RCSTA,ADEN
#define b_cren 		RCSTA,CREN
#define b_sren 		RCSTA,SREN
#define b_rx9  		RCSTA,RX9
#define b_spen 		RCSTA,SPEN
      
#define b_tx9d 		TXSTA,TX9D
#define b_trmt 		TXSTA,TRMT
#define b_brgh 		TXSTA,BRGH
#define b_sendb		TXSTA,SENDB
#define b_sync 		TXSTA,SYNC
#define b_txen 		TXSTA,TXEN
#define b_tx9  		TXSTA,TX9
#define b_csrc 		TXSTA,CSRC

